Unit AET1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, AA02C_p, UTAE12_p;

procedure AET1C(NM :Integer; N :Integer; LOW :Integer;
                IGH :Integer; var ORTR :Array of Real;
                var ORTI :Array of Real; var HR :Array of Real;
                var HI :Array of Real; var WR :Array of Real;
                var WI :Array of Real; var ZR :Array of Real;
                var ZI :Array of Real; var IERR :Integer);

implementation

procedure AET1C(NM :Integer; N :Integer; LOW :Integer;
                IGH :Integer; var ORTR :Array of Real;
                var ORTI :Array of Real; var HR :Array of Real;
                var HI :Array of Real; var WR :Array of Real;
                var WI :Array of Real; var ZR :Array of Real;
                var ZI :Array of Real; var IERR :Integer);
var
EN,ENM1,I,IEND,II,IP1,ITS,J,JJ,K,L,LL,LP1,M,NN :Integer;
BC2,BR2,F,F1,F2,F3,MACHEP,NORM,NORM1,SI,SR,TI,TR,XI,XI1,XR,XR1,YI,YR,
   ZZI,ZZR :Real;
CZ :Complex;
const
SYS056 :Real = 1.175495E-38;
SYS052 :Real = 1.1920928E-7;
label
_10,_20,_30,_40,_50,_60,_70,_80,_90,_100,_110,_120,_130,_140,_150,
_160,_170,_180,_190,_200,_210,_220,_230,_240,_250,_260,_270,_280,_290,
_300,_310,_320,_330,_340,_350,_360,_370,_380,_390,_400,_410,_420,_430,
_440,_450,_460,_470,_480,_490,_500;
begin
{      SYS056 = SYS055 }
MACHEP := SYS052;
IERR := 0;
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
    ZR[(I-1)+(J-1)*NM] := 0.00;
    ZI[(I-1)+(J-1)*NM] := 0.00;
    if ( I =  J ) 
     then ZR[(I-1)+(J-1)*NM] := 1.00;
_10:
   end;
_20:
 end;
IEND := IGH - LOW - 1;
if ( IEND ) < 0
 then goto _140
 else if ( IEND ) > 0
       then goto _30
       else goto _90;
_30:
for II:=1 to IEND do
 begin
  I := IGH - II;
  if ( ORTR[I-1] =  0.00 ) and (  ORTI[I-1] =  0.00 ) 
   then goto _80;
  if ( HR[(I-1)+(I-2)*NM] =  0.00 ) and (  HI[(I-1)+(I-2)*NM] =  0.00 )
   then goto _80;
  NORM := HR[(I-1)+(I-2)*NM]*ORTR[I-1] + HI[(I-1)+(I-2)*NM]*ORTI[I-1];
  IP1 := I + 1;
  for K:=IP1 to IGH do
   begin
    ORTR[K-1] := HR[(K-1)+(I-2)*NM];
    ORTI[K-1] := HI[(K-1)+(I-2)*NM];
_40:
   end;
  for J:=I to IGH do
   begin
    SR := 0.00;
    SI := 0.00;
    for K:=I to IGH do
     begin
      SR := SR + ORTR[K-1]*ZR[(K-1)+(J-1)*NM] + ORTI[K-1]*ZI[(K-1)+(J-1)*NM];
      SI := SI + ORTR[K-1]*ZI[(K-1)+(J-1)*NM] - ORTI[K-1]*ZR[(K-1)+(J-1)*NM];
_50:
     end;
    SR := SR/NORM;
    SI := SI/NORM;
    for K:=I to IGH do
     begin
      ZR[(K-1)+(J-1)*NM] := ZR[(K-1)+(J-1)*NM] + SR*ORTR[K-1] - SI*ORTI[K-1];
      ZI[(K-1)+(J-1)*NM] := ZI[(K-1)+(J-1)*NM] + SR*ORTR[K-1] + SI*ORTI[K-1];
_60:
     end;
_70:
   end;
_80:
 end;
_90:
L := LOW + 1;
for I:=L to IGH do
 begin
  LL := Min0(I+1,IGH);
  if ( HI[(I-1)+(I-2)*NM] =  0.00 ) 
   then goto _130;
  NORM := Cabs(Cmplx(HR[(I-1)+(I-2)*NM],HI[(I-1)+(I-2)*NM]));
  YR := HR[(I-1)+(I-2)*NM]/NORM;
  YI := HI[(I-1)+(I-2)*NM]/NORM;
  HR[(I-1)+(I-2)*NM] := NORM;
  HI[(I-1)+(I-2)*NM] := 0.00;
  for J:=I to N do
   begin
    SI := YR*HI[(I-1)+(J-1)*NM] - YI*HR[(I-1)+(J-1)*NM];
    HR[(I-1)+(J-1)*NM] := YR*HR[(I-1)+(J-1)*NM] + YI*HI[(I-1)+(J-1)*NM];
    HI[(I-1)+(J-1)*NM] := SI;
_100:
   end;
  for J:=1 to LL do
   begin
    SI := YR*HI[(J-1)+(I-1)*NM] + YI*HR[(J-1)+(I-1)*NM];
    HR[(J-1)+(I-1)*NM] := YR*HR[(J-1)+(I-1)*NM] - YI*HI[(J-1)+(I-1)*NM];
    HI[(J-1)+(I-1)*NM] := SI;
_110:
   end;
  for J:=LOW to IGH do
   begin
    SI := YR*ZI[(J-1)+(I-1)*NM] + YI*ZR[(J-1)+(I-1)*NM];
    ZR[(J-1)+(I-1)*NM] := YR*ZR[(J-1)+(I-1)*NM] - YI*ZI[(J-1)+(I-1)*NM];
    ZI[(J-1)+(I-1)*NM] := SI;
_120:
   end;
_130:
 end;
_140:
for I:=1 to N do
 begin
  if ( I >=  LOW ) and (  I <=  IGH ) 
   then goto _150;
  WR[I-1] := HR[(I-1)+(I-1)*NM];
  WI[I-1] := HI[(I-1)+(I-1)*NM];
_150:
 end;
EN := IGH;
TR := 0.00;
TI := 0.00;
NORM1 := 0.00;
II := LOW;
for I:=LOW to IGH do
 begin
  for J:=II to IGH do
   begin
    NORM1 := NORM1 + Abs(HR[(I-1)+(J-1)*NM]) + Abs(HI[(I-1)+(J-1)*NM]);
_160:
   end;
  II := I;
_170:
 end;
_180:
if ( EN <  LOW ) 
 then goto _370;
ITS := 0;
ENM1 := EN - 1;
_190:
for LL:=LOW to EN do
 begin
  L := EN + LOW - LL;
  if ( L =  LOW ) 
   then goto _210;
  F := Abs(HR[(L-2)+(L-2)*NM]) + Abs(HI[(L-2)+(L-2)*NM]) + Abs(HR[(L-1)+(L-1)*NM])
    + Abs(HI[(L-1)+(L-1)*NM]);
  if ( ITS >=  5 ) 
   then F := NORM1;
  if ( Abs(HR[(L-1)+(L-2)*NM]) <=  F*MACHEP ) 
   then goto _210;
_200:
 end;
_210:
if ( L =  EN ) 
 then goto _360;
if ( ITS =  30 ) 
 then goto _490;
if ( ITS =  10 ) or (  ITS =  20 ) 
 then goto _230;
SR := HR[(EN-1)+(EN-1)*NM];
SI := HI[(EN-1)+(EN-1)*NM];
F := EMax1(EMax1(EMax1(Abs(SR),Abs(SI)),Abs(HR[(ENM1-1)+(ENM1-1)*NM])),
    Abs(HI[(ENM1-1)+(ENM1-1)*NM]));
F := EMax1(EMax1(EMax1(F,Abs(HR[(EN-1)+(ENM1-1)*NM])),Abs(HR[(ENM1-1)+(EN-1)*NM])),
    Abs(HI[(ENM1-1)+(EN-1)*NM]));
if ( F <=  SYS056 )
 then goto _240;
XR := (HR[(ENM1-1)+(EN-1)*NM]/F)*(HR[(EN-1)+(ENM1-1)*NM]/F);
XI := (HI[(ENM1-1)+(EN-1)*NM]/F)*(HR[(EN-1)+(ENM1-1)*NM]/F);
if ( XR =  0.00 ) and (  XI =  0.00 )
 then goto _240;
YR := (HR[(ENM1-1)+(ENM1-1)*NM] - SR)/(2.00*F);
YI := (HI[(ENM1-1)+(ENM1-1)*NM] - SI)/(2.00*F);
XR1 := IntPower(YR,2) - IntPower(YI,2) + XR;
XI1 := 2.0*YR*YI + XI;
CZ := Csqrt(Cmplx(XR1,XI1));
ZZR := Creal(CZ);
ZZI := Aimag(CZ);
if ( YR*ZZR + YI*ZZI >=  0.00 ) 
 then goto _220;
ZZR := -ZZR;
ZZI := -ZZI;
_220:
BR2 := YR + ZZR;
BC2 := YI + ZZI;
AA02C(XR,XI,BR2,BC2,F1,F2);
SR := SR - F1*F;
SI := SI - F2*F;
goto _240;
_230:
SR := Abs(HR[(EN-1)+(ENM1-1)*NM]) + Abs(HR[(ENM1-1)+(EN-3)*NM]);
SI := 0.00;
_240:
for I:=LOW to EN do
 begin
  HR[(I-1)+(I-1)*NM] := HR[(I-1)+(I-1)*NM] - SR;
  HI[(I-1)+(I-1)*NM] := HI[(I-1)+(I-1)*NM] - SI;
_250:
 end;
TR := TR + SR;
TI := TI + SI;
ITS := ITS + 1;
LP1 := L + 1;
for I:=LP1 to EN do
 begin
  SR := HR[(I-1)+(I-2)*NM];
  HR[(I-1)+(I-2)*NM] := 0.00;
  F1 := Abs(HR[(I-2)+(I-2)*NM]);
  F2 := Abs(HI[(I-2)+(I-2)*NM]);
  F3 := Abs(SR);
  F := EMax1(EMax1(F1,F2),F3);
  F1 := F1/F;
  F2 := F2/F;
  F3 := F3/F;
  NORM := F*Sqrt(F1*F1+F2*F2+F3*F3);
  XR := HR[(I-2)+(I-2)*NM]/NORM;
  WR[I-2] := XR;
  XI := HI[(I-2)+(I-2)*NM]/NORM;
  WI[I-2] := XI;
  HR[(I-2)+(I-2)*NM] := NORM;
  HI[(I-2)+(I-2)*NM] := 0.00;
  HI[(I-1)+(I-2)*NM] := SR/NORM;
  for J:=I to N do
   begin
    YR := HR[(I-2)+(J-1)*NM];
    YI := HI[(I-2)+(J-1)*NM];
    ZZR := HR[(I-1)+(J-1)*NM];
    ZZI := HI[(I-1)+(J-1)*NM];
    HR[(I-2)+(J-1)*NM] := XR*YR + XI*YI + HI[(I-1)+(I-2)*NM]*ZZR;
    HI[(I-2)+(J-1)*NM] := XR*YI - XI*YR + HI[(I-1)+(I-2)*NM]*ZZI;
    HR[(I-1)+(J-1)*NM] := XR*ZZR - XI*ZZI - HI[(I-1)+(I-2)*NM]*YR;
    HI[(I-1)+(J-1)*NM] := XR*ZZI + XI*ZZR - HI[(I-1)+(I-2)*NM]*YI;
_260:
   end;
_270:
 end;
SI := HI[(EN-1)+(EN-1)*NM];
if ( SI =  0.00 ) 
 then goto _290;
NORM := Cabs(Cmplx(HR[(EN-1)+(EN-1)*NM],SI));
SR := HR[(EN-1)+(EN-1)*NM]/NORM;
SI := SI/NORM;
HR[(EN-1)+(EN-1)*NM] := NORM;
HI[(EN-1)+(EN-1)*NM] := 0.00;
if ( EN =  N ) 
 then goto _290;
IP1 := EN + 1;
for J:=IP1 to N do
 begin
  YR := HR[(EN-1)+(J-1)*NM];
  YI := HI[(EN-1)+(J-1)*NM];
  HR[(EN-1)+(J-1)*NM] := SR*YR + SI*YI;
  HI[(EN-1)+(J-1)*NM] := SR*YI - SI*YR;
_280:
 end;
_290:
for J:=LP1 to EN do
 begin
  XR := WR[J-2];
  XI := WI[J-2];
  for I:=1 to J do
   begin
    YR := HR[(I-1)+(J-2)*NM];
    YI := 0.00;
    ZZR := HR[(I-1)+(J-1)*NM];
    ZZI := HI[(I-1)+(J-1)*NM];
    if ( I =  J ) 
     then goto _300;
    YI := HI[(I-1)+(J-2)*NM];
    HI[(I-1)+(J-2)*NM] := XR*YI + XI*YR + HI[(J-1)+(J-2)*NM]
    *ZZI;
_300:
    HR[(I-1)+(J-2)*NM] := XR*YR - XI*YI + HI[(J-1)+(J-2)*NM]*ZZR;
    HR[(I-1)+(J-1)*NM] := XR*ZZR + XI*ZZI - HI[(J-1)+(J-2)*NM]*YR;
    HI[(I-1)+(J-1)*NM] := XR*ZZI - XI*ZZR - HI[(J-1)+(J-2)*NM]*YI;
_310:
   end;
  for I:=LOW to IGH do
   begin
    YR := ZR[(I-1)+(J-2)*NM];
    YI := ZI[(I-1)+(J-2)*NM];
    ZZR := ZR[(I-1)+(J-1)*NM];
    ZZI := ZI[(I-1)+(J-1)*NM];
    ZR[(I-1)+(J-2)*NM] := XR*YR - XI*YI + HI[(J-1)+(J-2)*NM]*ZZR;
    ZI[(I-1)+(J-2)*NM] := XR*YI + XI*YR + HI[(J-1)+(J-2)*NM]*ZZI;
    ZR[(I-1)+(J-1)*NM] := XR*ZZR + XI*ZZI - HI[(J-1)+(J-2)*NM]*YR;
    ZI[(I-1)+(J-1)*NM] := XR*ZZI - XI*ZZR - HI[(J-1)+(J-2)*NM]*YI;
_320:
   end;
_330:
 end;
if ( SI =  0.00 ) 
 then goto _190;
for I:=1 to EN do
 begin
  YR := HR[(I-1)+(EN-1)*NM];
  YI := HI[(I-1)+(EN-1)*NM];
  HR[(I-1)+(EN-1)*NM] := SR*YR - SI*YI;
  HI[(I-1)+(EN-1)*NM] := SR*YI + SI*YR;
_340:
 end;
for I:=LOW to IGH do
 begin
  YR := ZR[(I-1)+(EN-1)*NM];
  YI := ZI[(I-1)+(EN-1)*NM];
  ZR[(I-1)+(EN-1)*NM] := SR*YR - SI*YI;
  ZI[(I-1)+(EN-1)*NM] := SR*YI + SI*YR;
_350:
 end;
goto _190;
_360:
HR[(EN-1)+(EN-1)*NM] := HR[(EN-1)+(EN-1)*NM] + TR;
WR[EN-1] := HR[(EN-1)+(EN-1)*NM];
HI[(EN-1)+(EN-1)*NM] := HI[(EN-1)+(EN-1)*NM] + TI;
WI[EN-1] := HI[(EN-1)+(EN-1)*NM];
EN := ENM1;
goto _180;
_370:
NORM := 0.0;
for I:=1 to N do
 begin
  for J:=1 to N do
   begin
    NORM := NORM + Abs(HR[(I-1)+(J-1)*NM]) + Abs(HI[(I-1)+(J-1)*NM]);
_380:
   end;
_390:
 end;
if ( N =  1 ) or (  NORM =  0.0 ) 
 then goto _500;
for NN:=2 to N do
 begin
  EN := N + 2 - NN;
  XR := WR[EN-1];
  XI := WI[EN-1];
  ENM1 := EN - 1;
  for II:=1 to ENM1 do
   begin
    I := EN - II;
    ZZR := HR[(I-1)+(EN-1)*NM];
    ZZI := HI[(I-1)+(EN-1)*NM];
    if ( I =  ENM1 ) 
     then goto _410;
    IP1 := I + I;
    for J:=IP1 to ENM1 do
     begin
      ZZR := ZZR + HR[(I-1)+(J-1)*NM]*HR[(J-1)+(EN-1)*NM] - HI[(I-1)+(J-1)*NM]
    *HI[(J-1)+(EN-1)*NM];
      ZZI := ZZI + HR[(I-1)+(J-1)*NM]*HI[(J-1)+(EN-1)*NM] + HI[(I-1)+(J-1)*NM]
    *HR[(J-1)+(EN-1)*NM];
_400:
     end;
_410:
    YR := XR -WR[I-1];
    YI := XI - WI[I-1];
    F := MACHEP*NORM;
    F := EMax1(F,SYS056);
    if ( Abs(YR) <  F ) and (  Abs(YI) <  F ) 
     then YR := F;
    AA02C(ZZR,ZZI,YR,YI,HR[(I-1)+(EN-1)*NM],HI[(I-1)+(EN-1)*NM]);
_420:
   end;
_430:
 end;
ENM1 := N - 1;
for I:=1 to ENM1 do
 begin
  if ( I >=  LOW ) and (  I <=  IGH ) 
   then goto _450;
  IP1 := I + 1;
  for J:=IP1 to N do
   begin
    ZR[(I-1)+(J-1)*NM] := HR[(I-1)+(J-1)*NM];
    ZI[(I-1)+(J-1)*NM] := HI[(I-1)+(J-1)*NM];
_440:
   end;
_450:
 end;
for JJ:=LOW to ENM1 do
 begin
  J := N + LOW - JJ;
  M := Min0(J-1,IGH);
  for I:=LOW to IGH do
   begin
    ZZR := ZR[(I-1)+(J-1)*NM];
    ZZI := ZI[(I-1)+(J-1)*NM];
    for K:=LOW to M do
     begin
      ZZR := ZZR + ZR[(I-1)+(K-1)*NM]*HR[(K-1)+(J-1)*NM] - ZI[(I-1)+(K-1)*NM]*HI[(K-1)+(J-1)*NM];
      ZZI := ZZI + ZR[(I-1)+(K-1)*NM]*HI[(K-1)+(J-1)*NM] + ZI[(I-1)+(K-1)*NM]*HR[(K-1)+(J-1)*NM];
_460:
     end;
    ZR[(I-1)+(J-1)*NM] := ZZR;
    ZI[(I-1)+(J-1)*NM] := ZZI;
_470:
   end;
_480:
 end;
goto _500;
_490:
IERR := EN;
_500:
if ( IERR <>  0 ) 
 then UTAE12(IERR,N,7);
end;

end.
